// -*- C++ -*-
/*!
 * @file  And.cpp
 * @brief And component
 * $Date$
 *
 * $Id$
 */

#include "And.h"
#include <iostream>

// Module specification
// <rtc-template block="module_spec">
static const char* and_spec[] =
  {
    "implementation_id", "And",
    "type_name",         "And",
    "description",       "And component",
    "version",           "1.0",
    "vendor",            "MS_LAB",
    "category",          "",
    "activity_type",     "",
    "max_instance",      "",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables
    //"conf.default.DataType", "double",
    "conf.default.InPort_Num", "3",

    ""
  };
// </rtc-template>

And::And(RTC::Manager* manager)
  : RTC::DataFlowComponentBase(manager),
    // <rtc-template block="initializer">
    m_boolin0In("booleanin0", m_boolin0),
    m_boolin1In("booleanin1", m_boolin1),
    m_boolin2In("booleanin2", m_boolin2),
    m_boolin3In("booleanin3", m_boolin3),
    m_boolin4In("booleanin4", m_boolin4),
    m_boolin5In("booleanin5", m_boolin5),
    m_boolin6In("booleanin6", m_boolin6),
    m_boolin7In("booleanin7", m_boolin7),
    m_boolin8In("booleanin8", m_boolin8),
    m_boolin9In("booleanin9", m_boolin9),

    m_booloutOut("booleanout", m_boolout),
    
    // </rtc-template>
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  //registerInPort("datain", m_datainIn);
  
  // Set OutPort buffer
  //registerOutPort("dataout", m_dataoutOut);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

}

And::~And()
{
}


RTC::ReturnCode_t And::onInitialize()
{
  // <rtc-template block="bind_config">
  // Bind variables and configuration variable
  //bindParameter("DataType", m_DataType, "double");
  bindParameter("InPort_Num", m_InPort_Num, "3");
  
  // </rtc-template>
  std::cout << "And start." << std::endl;
  return RTC::RTC_OK;
}



RTC::ReturnCode_t And::onFinalize()
{
  RTC::Manager::instance().terminate();
  return RTC::RTC_OK;
}


bool svc_flag=false;
int svc_num=0;
bool activate_flag=true;

RTC::ReturnCode_t And::onActivated(RTC::UniqueId ec_id)
{
  if(activate_flag){

    if(svc_flag)
      num = svc_num;
    else
      num = m_InPort_Num;

    if(num < 1 || 10 < num){
      std::cout << "InPort_Num ERROR" << std::endl;
      return RTC::RTC_ERROR;
    }

    registerOutPort("booleanout", m_booloutOut);
    if(num > 0)
      registerInPort("booleanin0", m_boolin0In);
    if(num > 1)
      registerInPort("booleanin1", m_boolin1In);
    if(num > 2)
      registerInPort("booleanin2", m_boolin2In);
    if(num > 3)
      registerInPort("booleanin3", m_boolin3In);
    if(num > 4)
      registerInPort("booleanin4", m_boolin4In);
    if(num > 5)
      registerInPort("booleanin5", m_boolin5In);
    if(num > 6)
      registerInPort("booleanin6", m_boolin6In);
    if(num > 7)
      registerInPort("booleanin7", m_boolin7In);
    if(num > 8)
      registerInPort("booleanin8", m_boolin8In);
    if(num > 9)
      registerInPort("booleanin9", m_boolin9In);

    activate_flag=false;
  }

  return RTC::RTC_OK;
}


bool flag[10]={false, false, false, false, false, false, false, false, false, false};
bool boolnum[10] = {false, false, false, false, false, false, false, false, false, false};

RTC::ReturnCode_t And::onDeactivated(RTC::UniqueId ec_id)
{
  for(int i=0; i<10; i++){
    flag[i] = false;
    boolnum[i] = false;
  }
  m_boolin0In.read();
  m_boolin1In.read();
  m_boolin2In.read();
  m_boolin3In.read();
  m_boolin4In.read();
  m_boolin5In.read();
  m_boolin6In.read();
  m_boolin7In.read();
  m_boolin8In.read();
  m_boolin9In.read();

  return RTC::RTC_OK;
}



RTC::ReturnCode_t And::onExecute(RTC::UniqueId ec_id)
{
  bool all_read_flag=false;
  bool boolsum=false;

  if(num >= 1){
    if(m_boolin0In.isNew()){
      m_boolin0In.read();
      boolnum[0] = m_boolin0.data;
      flag[0] = true;
    }
  }
  if(num >= 2){
    if(m_boolin1In.isNew()){
      m_boolin1In.read();
      boolnum[1] = m_boolin1.data;
      flag[1] = true;
    }
  }
  if(num >= 3){
    if(m_boolin2In.isNew()){
      m_boolin2In.read();
      boolnum[2] = m_boolin2.data;
      flag[2] = true;
    }
  }
  if(num >= 4){
    if(m_boolin3In.isNew()){
      m_boolin3In.read();
      boolnum[3] = m_boolin3.data;
      flag[3] = true;
    }
  }
  if(num >= 5){
    if(m_boolin4In.isNew()){
      m_boolin4In.read();
      boolnum[4] = m_boolin4.data;
      flag[4] = true;
    }
  }
  if(num >= 6){
    if(m_boolin5In.isNew()){
      m_boolin5In.read();
      boolnum[5] = m_boolin5.data;
      flag[5] = true;
    }
  }
  if(num >= 7){
    if(m_boolin6In.isNew()){
      m_boolin6In.read();
      boolnum[6] = m_boolin6.data;
      flag[6] = true;
    }
  }
  if(num >= 8){
    if(m_boolin7In.isNew()){
      m_boolin7In.read();
      boolnum[7] = m_boolin7.data;
      flag[7] = true;
    }
  }
  if(num >= 9){
    if(m_boolin8In.isNew()){
      m_boolin8In.read();
      boolnum[8] = m_boolin8.data;
      flag[8] = true;
    }
  }
  if(num >= 10){
    if(m_boolin9In.isNew()){
      m_boolin9In.read();
      boolnum[9] = m_boolin9.data;
      flag[9] = true;
    }
  }

  all_read_flag = true;
  for(int i=0; i<num; i++){
    if(flag[i] == false)
      all_read_flag = false;
  }

  if(all_read_flag == true){
    boolsum = true;
    for(int i=0; i<num; i++){
      if(boolnum[i] == false)
        boolsum = false;
    }

    m_boolout.data = boolsum;
    m_booloutOut.write();

    for(int i=0; i<10; i++)
      flag[i] = false;
  }

  return RTC::RTC_OK;
}


/*
RTC::ReturnCode_t And::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t And::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t And::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t And::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t And::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void AndInit(RTC::Manager* manager)
  {
    RTC::Properties profile(and_spec);
    manager->registerFactory(profile,
                             RTC::Create<And>,
                             RTC::Delete<And>);
  }
  
};


