// -*- C++ -*-
/*!
 * @file  SelecterIIIO.cpp
 * @brief Selecter component
 * $Date$
 *
 * $Id$
 */

#include "SelecterIIIO.h"
#include <iostream>

#define SHORT 1
#define LONG 2
#define FLOAT 3
#define DOUBLE 4
#define BOOL 5
#define SHORTARRAY 10
#define LONGARRAY 20
#define FLOATARRAY 30
#define DOUBLEARRAY 40
#define BOOLARRAY 50

// Module specification
// <rtc-template block="module_spec">
static const char* selecteriiio_spec[] =
  {
    "implementation_id", "SelecterIIIO",
    "type_name",         "SelecterIIIO",
    "description",       "Selecter component",
    "version",           "1.0",
    "vendor",            "MS_LAB",
    "category",          "",
    "activity_type",     "",
    "max_instance",      "",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables
    "conf.default.DataType", "double",
    "conf.default.InPort_Num", "2",
    "conf.default.Select_Num", "1",

    ""
  };
// </rtc-template>

SelecterIIIO::SelecterIIIO(RTC::Manager* manager)
  : RTC::DataFlowComponentBase(manager),
    // <rtc-template block="initializer">
    m_shortin0In("shortin0", m_shortin0),
    m_shortin1In("shortin1", m_shortin1),
    m_shortin2In("shortin2", m_shortin2),
    m_shortin3In("shortin3", m_shortin3),
    m_shortin4In("shortin4", m_shortin4),
    m_shortin5In("shortin5", m_shortin5),
    m_shortin6In("shortin6", m_shortin6),
    m_shortin7In("shortin7", m_shortin7),
    m_shortin8In("shortin8", m_shortin8),
    m_shortin9In("shortin9", m_shortin9),
    m_longin0In("longin0", m_longin0),
    m_longin1In("longin1", m_longin1),
    m_longin2In("longin2", m_longin2),
    m_longin3In("longin3", m_longin3),
    m_longin4In("longin4", m_longin4),
    m_longin5In("longin5", m_longin5),
    m_longin6In("longin6", m_longin6),
    m_longin7In("longin7", m_longin7),
    m_longin8In("longin8", m_longin8),
    m_longin9In("longin9", m_longin9),
    m_floatin0In("floatin0", m_floatin0),
    m_floatin1In("floatin1", m_floatin1),
    m_floatin2In("floatin2", m_floatin2),
    m_floatin3In("floatin3", m_floatin3),
    m_floatin4In("floatin4", m_floatin4),
    m_floatin5In("floatin5", m_floatin5),
    m_floatin6In("floatin6", m_floatin6),
    m_floatin7In("floatin7", m_floatin7),
    m_floatin8In("floatin8", m_floatin8),
    m_floatin9In("floatin9", m_floatin9),
    m_doublein0In("doublein0", m_doublein0),
    m_doublein1In("doublein1", m_doublein1),
    m_doublein2In("doublein2", m_doublein2),
    m_doublein3In("doublein3", m_doublein3),
    m_doublein4In("doublein4", m_doublein4),
    m_doublein5In("doublein5", m_doublein5),
    m_doublein6In("doublein6", m_doublein6),
    m_doublein7In("doublein7", m_doublein7),
    m_doublein8In("doublein8", m_doublein8),
    m_doublein9In("doublein9", m_doublein9),
    m_boolin0In("booleanin0", m_boolin0),
    m_boolin1In("booleanin1", m_boolin1),
    m_boolin2In("booleanin2", m_boolin2),
    m_boolin3In("booleanin3", m_boolin3),
    m_boolin4In("booleanin4", m_boolin4),
    m_boolin5In("booleanin5", m_boolin5),
    m_boolin6In("booleanin6", m_boolin6),
    m_boolin7In("booleanin7", m_boolin7),
    m_boolin8In("booleanin8", m_boolin8),
    m_boolin9In("booleanin9", m_boolin9),

    m_sarrin0In("shortarrayin0", m_sarrin0),
    m_sarrin1In("shortarrayin1", m_sarrin1),
    m_sarrin2In("shortarrayin2", m_sarrin2),
    m_sarrin3In("shortarrayin3", m_sarrin3),
    m_sarrin4In("shortarrayin4", m_sarrin4),
    m_sarrin5In("shortarrayin5", m_sarrin5),
    m_sarrin6In("shortarrayin6", m_sarrin6),
    m_sarrin7In("shortarrayin7", m_sarrin7),
    m_sarrin8In("shortarrayin8", m_sarrin8),
    m_sarrin9In("shortarrayin9", m_sarrin9),
    m_larrin0In("longarrayin0", m_larrin0),
    m_larrin1In("longarrayin1", m_larrin1),
    m_larrin2In("longarrayin2", m_larrin2),
    m_larrin3In("longarrayin3", m_larrin3),
    m_larrin4In("longarrayin4", m_larrin4),
    m_larrin5In("longarrayin5", m_larrin5),
    m_larrin6In("longarrayin6", m_larrin6),
    m_larrin7In("longarrayin7", m_larrin7),
    m_larrin8In("longarrayin8", m_larrin8),
    m_larrin9In("longarrayin9", m_larrin9),
    m_farrin0In("floatarrayin0", m_farrin0),
    m_farrin1In("floatarrayin1", m_farrin1),
    m_farrin2In("floatarrayin2", m_farrin2),
    m_farrin3In("floatarrayin3", m_farrin3),
    m_farrin4In("floatarrayin4", m_farrin4),
    m_farrin5In("floatarrayin5", m_farrin5),
    m_farrin6In("floatarrayin6", m_farrin6),
    m_farrin7In("floatarrayin7", m_farrin7),
    m_farrin8In("floatarrayin8", m_farrin8),
    m_farrin9In("floatarrayin9", m_farrin9),
    m_darrin0In("doublearrayin0", m_darrin0),
    m_darrin1In("doublearrayin1", m_darrin1),
    m_darrin2In("doublearrayin2", m_darrin2),
    m_darrin3In("doublearrayin3", m_darrin3),
    m_darrin4In("doublearrayin4", m_darrin4),
    m_darrin5In("doublearrayin5", m_darrin5),
    m_darrin6In("doublearrayin6", m_darrin6),
    m_darrin7In("doublearrayin7", m_darrin7),
    m_darrin8In("doublearrayin8", m_darrin8),
    m_darrin9In("doublearrayin9", m_darrin9),
    m_barrin0In("booleanarrayin0", m_barrin0),
    m_barrin1In("booleanarrayin1", m_barrin1),
    m_barrin2In("booleanarrayin2", m_barrin2),
    m_barrin3In("booleanarrayin3", m_barrin3),
    m_barrin4In("booleanarrayin4", m_barrin4),
    m_barrin5In("booleanarrayin5", m_barrin5),
    m_barrin6In("booleanarrayin6", m_barrin6),
    m_barrin7In("booleanarrayin7", m_barrin7),
    m_barrin8In("booleanarrayin8", m_barrin8),
    m_barrin9In("booleanarrayin9", m_barrin9),

    m_shortoutOut("shortout", m_shortout),
    m_longoutOut("longout", m_longout),
    m_floatoutOut("floatout", m_floatout),
    m_doubleoutOut("doubleout", m_doubleout),
    m_booloutOut("booleanout", m_boolout),

    m_sarroutOut("shortarrayout", m_sarrout),
    m_larroutOut("longarrayout", m_larrout),
    m_farroutOut("floatarrayout", m_farrout),
    m_darroutOut("doublearrayout", m_darrout),
    m_barroutOut("booleanarrayout", m_barrout),

    m_PrvPortPort("PrvPort"),
    // </rtc-template>
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  //registerInPort("datain", m_datainIn);
  
  // Set OutPort buffer
  //registerOutPort("dataout", m_dataoutOut);
  
  // Set service provider to Ports
  m_PrvPortPort.registerProvider("selecteriiio", "selecteriiio", m_selecteriiio);
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  registerPort(m_PrvPortPort);
  
  // </rtc-template>

}

SelecterIIIO::~SelecterIIIO()
{
}


RTC::ReturnCode_t SelecterIIIO::onInitialize()
{
  // <rtc-template block="bind_config">
  // Bind variables and configuration variable
  bindParameter("DataType", m_DataType, "double");
  bindParameter("InPort_Num", m_InPort_Num, "2");
  bindParameter("Select_Num", m_Select_Num, "1");
  
  // </rtc-template>
  std::cout << "SeleterIIIO start." << std::endl;
  return RTC::RTC_OK;
}




RTC::ReturnCode_t SelecterIIIO::onFinalize()
{
  RTC::Manager::instance().terminate();
  return RTC::RTC_OK;
}



bool svc_flag=false;
int svc_type=0;
int svc_num=0;
int svc_select=1;
bool activate_flag=true;

RTC::ReturnCode_t SelecterIIIO::onActivated(RTC::UniqueId ec_id)
{
  if(activate_flag){

  if(svc_flag)
    type = svc_type;
  else{
    if(m_DataType!="short" && m_DataType!="long" && m_DataType!="float" && m_DataType!="double" && m_DataType!="bool" && m_DataType!="shortArray" && m_DataType!="longArray" && m_DataType!="floatArray" && m_DataType!="doubleArray" && m_DataType!="boolArray"){
      std::cout << "DataType ERROR" << std::endl;
      return RTC::RTC_ERROR;
    }
    if(m_DataType=="short")
      type = SHORT;
    else if(m_DataType=="long")
      type = LONG;
    else if(m_DataType=="float")
      type = FLOAT;
    else if(m_DataType=="double")
      type = DOUBLE;
    else if(m_DataType=="bool")
      type = BOOL;
    else if(m_DataType=="shortArray")
      type = SHORTARRAY;
    else if(m_DataType=="longArray")
      type = LONGARRAY;
    else if(m_DataType=="floatArray")
      type = FLOATARRAY;
    else if(m_DataType=="doubleArray")
      type = DOUBLEARRAY;
    else if(m_DataType=="boolArray")
      type = BOOLARRAY;
  }


  if(svc_flag)
    num = svc_num;
  else
    num = m_InPort_Num;

  if(num < 1 || 10 < num){
    std::cout << "InPort_Num ERROR" << std::endl;
    return RTC::RTC_ERROR;
  }


  switch(type){
    case SHORT:
      registerOutPort("shortout", m_shortoutOut);
      if(num > 0)
        registerInPort("shortin0", m_shortin0In);
      if(num > 1)
        registerInPort("shortin1", m_shortin1In);
      if(num > 2)
        registerInPort("shortin2", m_shortin2In);
      if(num > 3)
        registerInPort("shortin3", m_shortin3In);
      if(num > 4)
        registerInPort("shortin4", m_shortin4In);
      if(num > 5)
        registerInPort("shortin5", m_shortin5In);
      if(num > 6)
        registerInPort("shortin6", m_shortin6In);
      if(num > 7)
        registerInPort("shortin7", m_shortin7In);
      if(num > 8)
        registerInPort("shortin8", m_shortin8In);
      if(num > 9)
        registerInPort("shortin9", m_shortin9In);
    break;

    case LONG:
      registerOutPort("longout", m_longoutOut);
      if(num > 0)
        registerInPort("longin0", m_longin0In);
      if(num > 1)
        registerInPort("longin1", m_longin1In);
      if(num > 2)
        registerInPort("longin2", m_longin2In);
      if(num > 3)
        registerInPort("longin3", m_longin3In);
      if(num > 4)
        registerInPort("longin4", m_longin4In);
      if(num > 5)
        registerInPort("longin5", m_longin5In);
      if(num > 6)
        registerInPort("longin6", m_longin6In);
      if(num > 7)
        registerInPort("longin7", m_longin7In);
      if(num > 8)
        registerInPort("longin8", m_longin8In);
      if(num > 9)
        registerInPort("longin9", m_longin9In);
    break;

    case FLOAT:
      registerOutPort("floatout", m_floatoutOut);
      if(num > 0)
        registerInPort("floatin0", m_floatin0In);
      if(num > 1)
        registerInPort("floatin1", m_floatin1In);
      if(num > 2)
        registerInPort("floatin2", m_floatin2In);
      if(num > 3)
        registerInPort("floatin3", m_floatin3In);
      if(num > 4)
        registerInPort("floatin4", m_floatin4In);
      if(num > 5)
        registerInPort("floatin5", m_floatin5In);
      if(num > 6)
        registerInPort("floatin6", m_floatin6In);
      if(num > 7)
        registerInPort("floatin7", m_floatin7In);
      if(num > 8)
        registerInPort("floatin8", m_floatin8In);
      if(num > 9)
        registerInPort("floatin9", m_floatin9In);
    break;

    case DOUBLE:
      registerOutPort("doubleout", m_doubleoutOut);
      if(num > 0)
        registerInPort("doublein0", m_doublein0In);
      if(num > 1)
        registerInPort("doublein1", m_doublein1In);
      if(num > 2)
        registerInPort("doublein2", m_doublein2In);
      if(num > 3)
        registerInPort("doublein3", m_doublein3In);
      if(num > 4)
        registerInPort("doublein4", m_doublein4In);
      if(num > 5)
        registerInPort("doublein5", m_doublein5In);
      if(num > 6)
        registerInPort("doublein6", m_doublein6In);
      if(num > 7)
        registerInPort("doublein7", m_doublein7In);
      if(num > 8)
        registerInPort("doublein8", m_doublein8In);
      if(num > 9)
        registerInPort("doublein9", m_doublein9In);
    break;

    case BOOL:
      registerOutPort("booleanout", m_booloutOut);
      if(num > 0)
        registerInPort("booleanin0", m_boolin0In);
      if(num > 1)
        registerInPort("booleanin1", m_boolin1In);
      if(num > 2)
        registerInPort("booleanin2", m_boolin2In);
      if(num > 3)
        registerInPort("booleanin3", m_boolin3In);
      if(num > 4)
        registerInPort("booleanin4", m_boolin4In);
      if(num > 5)
        registerInPort("booleanin5", m_boolin5In);
      if(num > 6)
        registerInPort("booleanin6", m_boolin6In);
      if(num > 7)
        registerInPort("booleanin7", m_boolin7In);
      if(num > 8)
        registerInPort("booleanin8", m_boolin8In);
      if(num > 9)
        registerInPort("booleanin9", m_boolin9In);
    break;

    case SHORTARRAY:
      registerOutPort("shortArrayout", m_sarroutOut);
      if(num > 0)
        registerInPort("shortArrayin0", m_sarrin0In);
      if(num > 1)
        registerInPort("shortArrayin1", m_sarrin1In);
      if(num > 2)
        registerInPort("shortArrayin2", m_sarrin2In);
      if(num > 3)
        registerInPort("shortArrayin3", m_sarrin3In);
      if(num > 4)
        registerInPort("shortArrayin4", m_sarrin4In);
      if(num > 5)
        registerInPort("shortArrayin5", m_sarrin5In);
      if(num > 6)
        registerInPort("shortArrayin6", m_sarrin6In);
      if(num > 7)
        registerInPort("shortArrayin7", m_sarrin7In);
      if(num > 8)
        registerInPort("shortArrayin8", m_sarrin8In);
      if(num > 9)
        registerInPort("shortArrayin9", m_sarrin9In);
    break;

    case LONGARRAY:
      registerOutPort("longArrayout", m_larroutOut);
      if(num > 0)
        registerInPort("longArrayin0", m_larrin0In);
      if(num > 1)
        registerInPort("longArrayin1", m_larrin1In);
      if(num > 2)
        registerInPort("longArrayin2", m_larrin2In);
      if(num > 3)
        registerInPort("longArrayin3", m_larrin3In);
      if(num > 4)
        registerInPort("longArrayin4", m_larrin4In);
      if(num > 5)
        registerInPort("longArrayin5", m_larrin5In);
      if(num > 6)
        registerInPort("longArrayin6", m_larrin6In);
      if(num > 7)
        registerInPort("longArrayin7", m_larrin7In);
      if(num > 8)
        registerInPort("longArrayin8", m_larrin8In);
      if(num > 9)
        registerInPort("longArrayin9", m_larrin9In);
    break;

    case FLOATARRAY:
      registerOutPort("floatArrayout", m_farroutOut);
      if(num > 0)
        registerInPort("floatArrayin0", m_farrin0In);
      if(num > 1)
        registerInPort("floatArrayin1", m_farrin1In);
      if(num > 2)
        registerInPort("floatArrayin2", m_farrin2In);
      if(num > 3)
        registerInPort("floatArrayin3", m_farrin3In);
      if(num > 4)
        registerInPort("floatArrayin4", m_farrin4In);
      if(num > 5)
        registerInPort("floatArrayin5", m_farrin5In);
      if(num > 6)
        registerInPort("floatArrayin6", m_farrin6In);
      if(num > 7)
        registerInPort("floatArrayin7", m_farrin7In);
      if(num > 8)
        registerInPort("floatArrayin8", m_farrin8In);
      if(num > 9)
        registerInPort("floatArrayin9", m_farrin9In);
    break;

    case DOUBLEARRAY:
      registerOutPort("doubleArrayout", m_darroutOut);
      if(num > 0)
        registerInPort("doubleArrayin0", m_darrin0In);
      if(num > 1)
        registerInPort("doubleArrayin1", m_darrin1In);
      if(num > 2)
        registerInPort("doubleArrayin2", m_darrin2In);
      if(num > 3)
        registerInPort("doubleArrayin3", m_darrin3In);
      if(num > 4)
        registerInPort("doubleArrayin4", m_darrin4In);
      if(num > 5)
        registerInPort("doubleArrayin5", m_darrin5In);
      if(num > 6)
        registerInPort("doubleArrayin6", m_darrin6In);
      if(num > 7)
        registerInPort("doubleArrayin7", m_darrin7In);
      if(num > 8)
        registerInPort("doubleArrayin8", m_darrin8In);
      if(num > 9)
        registerInPort("doubleArrayin9", m_darrin9In);
    break;

    case BOOLARRAY:
      registerOutPort("booleanArrayout", m_barroutOut);
      if(num > 0)
        registerInPort("booleanArrayin0", m_barrin0In);
      if(num > 1)
        registerInPort("booleanArrayin1", m_barrin1In);
      if(num > 2)
        registerInPort("booleanArrayin2", m_barrin2In);
      if(num > 3)
        registerInPort("booleanArrayin3", m_barrin3In);
      if(num > 4)
        registerInPort("booleanArrayin4", m_barrin4In);
      if(num > 5)
        registerInPort("booleanArrayin5", m_barrin5In);
      if(num > 6)
        registerInPort("booleanArrayin6", m_barrin6In);
      if(num > 7)
        registerInPort("booleanArrayin7", m_barrin7In);
      if(num > 8)
        registerInPort("booleanArrayin8", m_barrin8In);
      if(num > 9)
        registerInPort("booleanArrayin9", m_barrin9In);
    break;
  }

  activate_flag=false;
  }

  return RTC::RTC_OK;
}



RTC::ReturnCode_t SelecterIIIO::onDeactivated(RTC::UniqueId ec_id)
{
  m_shortin0In.read();
  m_shortin1In.read();
  m_shortin2In.read();
  m_shortin3In.read();
  m_shortin4In.read();
  m_shortin5In.read();
  m_shortin6In.read();
  m_shortin7In.read();
  m_shortin8In.read();
  m_shortin9In.read();
  m_longin0In.read();
  m_longin1In.read();
  m_longin2In.read();
  m_longin3In.read();
  m_longin4In.read();
  m_longin5In.read();
  m_longin6In.read();
  m_longin7In.read();
  m_longin8In.read();
  m_longin9In.read();
  m_floatin0In.read();
  m_floatin1In.read();
  m_floatin2In.read();
  m_floatin3In.read();
  m_floatin4In.read();
  m_floatin5In.read();
  m_floatin6In.read();
  m_floatin7In.read();
  m_floatin8In.read();
  m_floatin9In.read();
  m_doublein0In.read();
  m_doublein1In.read();
  m_doublein2In.read();
  m_doublein3In.read();
  m_doublein4In.read();
  m_doublein5In.read();
  m_doublein6In.read();
  m_doublein7In.read();
  m_doublein8In.read();
  m_doublein9In.read();
  m_boolin0In.read();
  m_boolin1In.read();
  m_boolin2In.read();
  m_boolin3In.read();
  m_boolin4In.read();
  m_boolin5In.read();
  m_boolin6In.read();
  m_boolin7In.read();
  m_boolin8In.read();
  m_boolin9In.read();
  m_sarrin0In.read();
  m_sarrin1In.read();
  m_sarrin2In.read();
  m_sarrin3In.read();
  m_sarrin4In.read();
  m_sarrin5In.read();
  m_sarrin6In.read();
  m_sarrin7In.read();
  m_sarrin8In.read();
  m_sarrin9In.read();
  m_larrin0In.read();
  m_larrin1In.read();
  m_larrin2In.read();
  m_larrin3In.read();
  m_larrin4In.read();
  m_larrin5In.read();
  m_larrin6In.read();
  m_larrin7In.read();
  m_larrin8In.read();
  m_larrin9In.read();
  m_farrin0In.read();
  m_farrin1In.read();
  m_farrin2In.read();
  m_farrin3In.read();
  m_farrin4In.read();
  m_farrin5In.read();
  m_farrin6In.read();
  m_farrin7In.read();
  m_farrin8In.read();
  m_farrin9In.read();
  m_darrin0In.read();
  m_darrin1In.read();
  m_darrin2In.read();
  m_darrin3In.read();
  m_darrin4In.read();
  m_darrin5In.read();
  m_darrin6In.read();
  m_darrin7In.read();
  m_darrin8In.read();
  m_darrin9In.read();
  m_barrin0In.read();
  m_barrin1In.read();
  m_barrin2In.read();
  m_barrin3In.read();
  m_barrin4In.read();
  m_barrin5In.read();
  m_barrin6In.read();
  m_barrin7In.read();
  m_barrin8In.read();
  m_barrin9In.read();

  return RTC::RTC_OK;
}



RTC::ReturnCode_t SelecterIIIO::onExecute(RTC::UniqueId ec_id)
{
  bool flag[10]={false, false, false, false, false, false, false, false, false, false};
  static short shortnum[10] = {0};
  static long longnum[10] = {0};
  static float floatnum[10] = {0};
  static double doublenum[10] = {0};
  static bool boolnum[10] = {0};
  //int selement = 0, lelement = 0, felement = 0, delement = 0, belement = 0;
  std::vector<short> sarrnum[10];
  std::vector<long> larrnum[10];
  std::vector<float> farrnum[10];
  std::vector<double> darrnum[10];
  std::vector<bool> barrnum[10];

  if(svc_flag)
    select = svc_select;
  else{
    if(m_Select_Num < 1 || num < m_Select_Num){
      std::cout << "Select ERROR." << std::endl;
      select = 1;
    }
    else 
      select = m_Select_Num;
  }

  //if(select == 1){
  switch(type){
    case SHORT:
      if(m_shortin0In.isNew()){
        m_shortin0In.read();
        shortnum[0] = m_shortin0.data;
        flag[0] = true;
      }
      if(m_shortin1In.isNew()){
        m_shortin1In.read();
        shortnum[1] = m_shortin1.data;
        flag[1] = true;
      }
      if(m_shortin2In.isNew()){
        m_shortin2In.read();
        shortnum[2] = m_shortin2.data;
        flag[2] = true;
      }
      if(m_shortin3In.isNew()){
        m_shortin3In.read();
        shortnum[3] = m_shortin3.data;
        flag[3] = true;
      }
      if(m_shortin4In.isNew()){
        m_shortin4In.read();
        shortnum[4] = m_shortin4.data;
        flag[4] = true;
      }
      if(m_shortin5In.isNew()){
        m_shortin5In.read();
        shortnum[5] = m_shortin5.data;
        flag[5] = true;
      }
      if(m_shortin6In.isNew()){
        m_shortin6In.read();
        shortnum[6] = m_shortin6.data;
        flag[6] = true;
      }
      if(m_shortin7In.isNew()){
        m_shortin7In.read();
        shortnum[7] = m_shortin7.data;
        flag[7] = true;
      }
      if(m_shortin8In.isNew()){
        m_shortin8In.read();
        shortnum[8] = m_shortin8.data;
        flag[8] = true;
      }
      if(m_shortin9In.isNew()){
        m_shortin9In.read();
        shortnum[9] = m_shortin9.data;
        flag[9] = true;
      }
    break;

    case LONG:
      if(m_longin0In.isNew()){
        m_longin0In.read();
        longnum[0] = m_longin0.data;
        flag[0] = true;
      }
      if(m_longin1In.isNew()){
        m_longin1In.read();
        longnum[1] = m_longin1.data;
        flag[1] = true;
      }
      if(m_longin2In.isNew()){
        m_longin2In.read();
        longnum[2] = m_longin2.data;
        flag[2] = true;
      }
      if(m_longin3In.isNew()){
        m_longin3In.read();
        longnum[3] = m_longin3.data;
        flag[3] = true;
      }
      if(m_longin4In.isNew()){
        m_longin4In.read();
        longnum[4] = m_longin4.data;
        flag[4] = true;
      }
      if(m_longin5In.isNew()){
        m_longin5In.read();
        longnum[5] = m_longin5.data;
        flag[5] = true;
      }
      if(m_longin6In.isNew()){
        m_longin6In.read();
        longnum[6] = m_longin6.data;
        flag[6] = true;
      }
      if(m_longin7In.isNew()){
        m_longin7In.read();
        longnum[7] = m_longin7.data;
        flag[7] = true;
      }
      if(m_longin8In.isNew()){
        m_longin8In.read();
        longnum[8] = m_longin8.data;
        flag[8] = true;
      }
      if(m_longin9In.isNew()){
        m_longin9In.read();
        longnum[9] = m_longin9.data;
        flag[9] = true;
      }
    break;

    case FLOAT:
      if(m_floatin0In.isNew()){
        m_floatin0In.read();
        floatnum[0] = m_floatin0.data;
        flag[0] = true;
      }
      if(m_floatin1In.isNew()){
        m_floatin1In.read();
        floatnum[1] = m_floatin1.data;
        flag[1] = true;
      }
      if(m_floatin2In.isNew()){
        m_floatin2In.read();
        floatnum[2] = m_floatin2.data;
        flag[2] = true;
      }
      if(m_floatin3In.isNew()){
        m_floatin3In.read();
        floatnum[3] = m_floatin3.data;
        flag[3] = true;
      }
      if(m_floatin4In.isNew()){
        m_floatin4In.read();
        floatnum[4] = m_floatin4.data;
        flag[4] = true;
      }
      if(m_floatin5In.isNew()){
        m_floatin5In.read();
        floatnum[5] = m_floatin5.data;
        flag[5] = true;
      }
      if(m_floatin6In.isNew()){
        m_floatin6In.read();
        floatnum[6] = m_floatin6.data;
        flag[6] = true;
      }
      if(m_floatin7In.isNew()){
        m_floatin7In.read();
        floatnum[7] = m_floatin7.data;
        flag[7] = true;
      }
      if(m_floatin8In.isNew()){
        m_floatin8In.read();
        floatnum[8] = m_floatin8.data;
        flag[8] = true;
      }
      if(m_floatin9In.isNew()){
        m_floatin9In.read();
        floatnum[9] = m_floatin9.data;
        flag[9] = true;
      }
    break;

    case DOUBLE:
      if(m_doublein0In.isNew()){
        m_doublein0In.read();
        doublenum[0] = m_doublein0.data;
        flag[0] = true;
      }
      if(m_doublein1In.isNew()){
        m_doublein1In.read();
        doublenum[1] = m_doublein1.data;
        flag[1] = true;
      }
      if(m_doublein2In.isNew()){
        m_doublein2In.read();
        doublenum[2] = m_doublein2.data;
        flag[2] = true;
      }
      if(m_doublein3In.isNew()){
        m_doublein3In.read();
        doublenum[3] = m_doublein3.data;
        flag[3] = true;
      }
      if(m_doublein4In.isNew()){
        m_doublein4In.read();
        doublenum[4] = m_doublein4.data;
        flag[4] = true;
      }
      if(m_doublein5In.isNew()){
        m_doublein5In.read();
        doublenum[5] = m_doublein5.data;
        flag[5] = true;
      }
      if(m_doublein6In.isNew()){
        m_doublein6In.read();
        doublenum[6] = m_doublein6.data;
        flag[6] = true;
      }
      if(m_doublein7In.isNew()){
        m_doublein7In.read();
        doublenum[7] = m_doublein7.data;
        flag[7] = true;
      }
      if(m_doublein8In.isNew()){
        m_doublein8In.read();
        doublenum[8] = m_doublein8.data;
        flag[8] = true;
      }
      if(m_doublein9In.isNew()){
        m_doublein9In.read();
        doublenum[9] = m_doublein9.data;
        flag[9] = true;
      }
    break;

    case BOOL:
      if(m_boolin0In.isNew()){
        m_boolin0In.read();
        boolnum[0] = m_boolin0.data;
        flag[0] = true;
      }
      if(m_boolin1In.isNew()){
        m_boolin1In.read();
        boolnum[1] = m_boolin1.data;
        flag[1] = true;
      }
      if(m_boolin2In.isNew()){
        m_boolin2In.read();
        boolnum[2] = m_boolin2.data;
        flag[2] = true;
      }
      if(m_boolin3In.isNew()){
        m_boolin3In.read();
        boolnum[3] = m_boolin3.data;
        flag[3] = true;
      }
      if(m_boolin4In.isNew()){
        m_boolin4In.read();
        boolnum[4] = m_boolin4.data;
        flag[4] = true;
      }
      if(m_boolin5In.isNew()){
        m_boolin5In.read();
        boolnum[5] = m_boolin5.data;
        flag[5] = true;
      }
      if(m_boolin6In.isNew()){
        m_boolin6In.read();
        boolnum[6] = m_boolin6.data;
        flag[6] = true;
      }
      if(m_boolin7In.isNew()){
        m_boolin7In.read();
        boolnum[7] = m_boolin7.data;
        flag[7] = true;
      }
      if(m_boolin8In.isNew()){
        m_boolin8In.read();
        boolnum[8] = m_boolin8.data;
        flag[8] = true;
      }
      if(m_boolin9In.isNew()){
        m_boolin9In.read();
        boolnum[9] = m_boolin9.data;
        flag[9] = true;
      }
    break;

    case SHORTARRAY:
      if(m_sarrin0In.isNew()){
        m_sarrin0In.read();
        for(int i=0,len=m_sarrin0.data.length(); i<len; i++)
          sarrnum[0].push_back(m_sarrin0.data[i]);
        flag[0] = true;
      }
      if(m_sarrin1In.isNew()){
        m_sarrin1In.read();
        for(int i=0,len=m_sarrin1.data.length(); i<len; i++)
          sarrnum[1].push_back(m_sarrin1.data[i]);
        flag[1] = true;
      }
      if(m_sarrin2In.isNew()){
        m_sarrin2In.read();
        for(int i=0,len=m_sarrin2.data.length(); i<len; i++)
          sarrnum[2].push_back(m_sarrin2.data[i]);
        flag[2] = true;
      }
      if(m_sarrin3In.isNew()){
        m_sarrin3In.read();
        for(int i=0,len=m_sarrin3.data.length(); i<len; i++)
          sarrnum[3].push_back(m_sarrin3.data[i]);
        flag[3] = true;
      }
      if(m_sarrin4In.isNew()){
        m_sarrin4In.read();
        for(int i=0,len=m_sarrin4.data.length(); i<len; i++)
          sarrnum[4].push_back(m_sarrin4.data[i]);
        flag[4] = true;
      }
      if(m_sarrin5In.isNew()){
        m_sarrin5In.read();
        for(int i=0,len=m_sarrin5.data.length(); i<len; i++)
          sarrnum[5].push_back(m_sarrin5.data[i]);
        flag[5] = true;
      }
      if(m_sarrin6In.isNew()){
        m_sarrin6In.read();
        for(int i=0,len=m_sarrin6.data.length(); i<len; i++)
          sarrnum[6].push_back(m_sarrin6.data[i]);
        flag[6] = true;
      }
      if(m_sarrin7In.isNew()){
        m_sarrin7In.read();
        for(int i=0,len=m_sarrin7.data.length(); i<len; i++)
          sarrnum[7].push_back(m_sarrin7.data[i]);
        flag[7] = true;
      }
      if(m_sarrin8In.isNew()){
        m_sarrin8In.read();
        for(int i=0,len=m_sarrin8.data.length(); i<len; i++)
          sarrnum[8].push_back(m_sarrin8.data[i]);
        flag[8] = true;
      }
      if(m_sarrin9In.isNew()){
        m_sarrin9In.read();
        for(int i=0,len=m_sarrin9.data.length(); i<len; i++)
          sarrnum[9].push_back(m_sarrin9.data[i]);
        flag[9] = true;
      }
    break;

    case LONGARRAY:
      if(m_larrin0In.isNew()){
        m_larrin0In.read();
        for(int i=0,len=m_larrin0.data.length(); i<len; i++)
          larrnum[0].push_back(m_larrin0.data[i]);
        flag[0] = true;
      }
      if(m_larrin1In.isNew()){
        m_larrin1In.read();
        for(int i=0,len=m_larrin1.data.length(); i<len; i++)
          larrnum[1].push_back(m_larrin1.data[i]);
        flag[1] = true;
      }
      if(m_larrin2In.isNew()){
        m_larrin2In.read();
        for(int i=0,len=m_larrin2.data.length(); i<len; i++)
          larrnum[2].push_back(m_larrin2.data[i]);
        flag[2] = true;
      }
      if(m_larrin3In.isNew()){
        m_larrin3In.read();
        for(int i=0,len=m_larrin3.data.length(); i<len; i++)
          larrnum[3].push_back(m_larrin3.data[i]);
        flag[3] = true;
      }
      if(m_larrin4In.isNew()){
        m_larrin4In.read();
        for(int i=0,len=m_larrin4.data.length(); i<len; i++)
          larrnum[4].push_back(m_larrin4.data[i]);
        flag[4] = true;
      }
      if(m_larrin5In.isNew()){
        m_larrin5In.read();
        for(int i=0,len=m_larrin5.data.length(); i<len; i++)
          larrnum[5].push_back(m_larrin5.data[i]);
        flag[5] = true;
      }
      if(m_larrin6In.isNew()){
        m_larrin6In.read();
        for(int i=0,len=m_larrin6.data.length(); i<len; i++)
          larrnum[6].push_back(m_larrin6.data[i]);
        flag[6] = true;
      }
      if(m_larrin7In.isNew()){
        m_larrin7In.read();
        for(int i=0,len=m_larrin7.data.length(); i<len; i++)
          larrnum[7].push_back(m_larrin7.data[i]);
        flag[7] = true;
      }
      if(m_larrin8In.isNew()){
        m_larrin8In.read();
        for(int i=0,len=m_larrin8.data.length(); i<len; i++)
          larrnum[8].push_back(m_larrin8.data[i]);
        flag[8] = true;
      }
      if(m_larrin9In.isNew()){
        m_larrin9In.read();
        for(int i=0,len=m_larrin9.data.length(); i<len; i++)
          larrnum[9].push_back(m_larrin9.data[i]);
        flag[9] = true;
      }
    break;

    case FLOATARRAY:
      if(m_farrin0In.isNew()){
        m_farrin0In.read();
        for(int i=0,len=m_farrin0.data.length(); i<len; i++)
          farrnum[0].push_back(m_farrin0.data[i]);
        flag[0] = true;
      }
      if(m_farrin1In.isNew()){
        m_farrin1In.read();
        for(int i=0,len=m_farrin1.data.length(); i<len; i++)
          farrnum[1].push_back(m_farrin1.data[i]);
        flag[1] = true;
      }
      if(m_farrin2In.isNew()){
        m_farrin2In.read();
        for(int i=0,len=m_farrin2.data.length(); i<len; i++)
          farrnum[2].push_back(m_farrin2.data[i]);
        flag[2] = true;
      }
      if(m_farrin3In.isNew()){
        m_farrin3In.read();
        for(int i=0,len=m_farrin3.data.length(); i<len; i++)
          farrnum[3].push_back(m_farrin3.data[i]);
        flag[3] = true;
      }
      if(m_farrin4In.isNew()){
        m_farrin4In.read();
        for(int i=0,len=m_farrin4.data.length(); i<len; i++)
          farrnum[4].push_back(m_farrin4.data[i]);
        flag[4] = true;
      }
      if(m_farrin5In.isNew()){
        m_farrin5In.read();
        for(int i=0,len=m_farrin5.data.length(); i<len; i++)
          farrnum[5].push_back(m_farrin5.data[i]);
        flag[5] = true;
      }
      if(m_farrin6In.isNew()){
        m_farrin6In.read();
        for(int i=0,len=m_farrin6.data.length(); i<len; i++)
          farrnum[6].push_back(m_farrin6.data[i]);
        flag[6] = true;
      }
      if(m_farrin7In.isNew()){
        m_farrin7In.read();
        for(int i=0,len=m_farrin7.data.length(); i<len; i++)
          farrnum[7].push_back(m_farrin7.data[i]);
        flag[7] = true;
      }
      if(m_farrin8In.isNew()){
        m_farrin8In.read();
        for(int i=0,len=m_farrin8.data.length(); i<len; i++)
          farrnum[8].push_back(m_farrin8.data[i]);
        flag[8] = true;
      }
      if(m_farrin9In.isNew()){
        m_farrin9In.read();
        for(int i=0,len=m_farrin9.data.length(); i<len; i++)
          farrnum[9].push_back(m_farrin9.data[i]);
        flag[9] = true;
      }
    break;

    case DOUBLEARRAY:
      if(m_darrin0In.isNew()){
        m_darrin0In.read();
        for(int i=0,len=m_darrin0.data.length(); i<len; i++)
          darrnum[0].push_back(m_darrin0.data[i]);
        flag[0] = true;
      }
      if(m_darrin1In.isNew()){
        m_darrin1In.read();
        for(int i=0,len=m_darrin1.data.length(); i<len; i++)
          darrnum[1].push_back(m_darrin1.data[i]);
        flag[1] = true;
      }
      if(m_darrin2In.isNew()){
        m_darrin2In.read();
        for(int i=0,len=m_darrin2.data.length(); i<len; i++)
          darrnum[2].push_back(m_darrin2.data[i]);
        flag[2] = true;
      }
      if(m_darrin3In.isNew()){
        m_darrin3In.read();
        for(int i=0,len=m_darrin3.data.length(); i<len; i++)
          darrnum[3].push_back(m_darrin3.data[i]);
        flag[3] = true;
      }
      if(m_darrin4In.isNew()){
        m_darrin4In.read();
        for(int i=0,len=m_darrin4.data.length(); i<len; i++)
          darrnum[4].push_back(m_darrin4.data[i]);
        flag[4] = true;
      }
      if(m_darrin5In.isNew()){
        m_darrin5In.read();
        for(int i=0,len=m_darrin5.data.length(); i<len; i++)
          darrnum[5].push_back(m_darrin5.data[i]);
        flag[5] = true;
      }
      if(m_darrin6In.isNew()){
        m_darrin6In.read();
        for(int i=0,len=m_darrin6.data.length(); i<len; i++)
          darrnum[6].push_back(m_darrin6.data[i]);
        flag[6] = true;
      }
      if(m_darrin7In.isNew()){
        m_darrin7In.read();
        for(int i=0,len=m_darrin7.data.length(); i<len; i++)
          darrnum[7].push_back(m_darrin7.data[i]);
        flag[7] = true;
      }
      if(m_darrin8In.isNew()){
        m_darrin8In.read();
        for(int i=0,len=m_darrin8.data.length(); i<len; i++)
          darrnum[8].push_back(m_darrin8.data[i]);
        flag[8] = true;
      }
      if(m_darrin9In.isNew()){
        m_darrin9In.read();
        for(int i=0,len=m_darrin9.data.length(); i<len; i++)
          darrnum[9].push_back(m_darrin9.data[i]);
        flag[9] = true;
      }
    break;

    case BOOLARRAY:
      if(m_barrin0In.isNew()){
        m_barrin0In.read();
        for(int i=0,len=m_barrin0.data.length(); i<len; i++)
          barrnum[0].push_back(m_barrin0.data[i]);
        flag[0] = true;
      }
      if(m_barrin1In.isNew()){
        m_barrin1In.read();
        for(int i=0,len=m_barrin1.data.length(); i<len; i++)
          barrnum[1].push_back(m_barrin1.data[i]);
        flag[1] = true;
      }
      if(m_barrin2In.isNew()){
        m_barrin2In.read();
        for(int i=0,len=m_barrin2.data.length(); i<len; i++)
          barrnum[2].push_back(m_barrin2.data[i]);
        flag[2] = true;
      }
      if(m_barrin3In.isNew()){
        m_barrin3In.read();
        for(int i=0,len=m_barrin3.data.length(); i<len; i++)
          barrnum[3].push_back(m_barrin3.data[i]);
        flag[3] = true;
      }
      if(m_barrin4In.isNew()){
        m_barrin4In.read();
        for(int i=0,len=m_barrin4.data.length(); i<len; i++)
          barrnum[4].push_back(m_barrin4.data[i]);
        flag[4] = true;
      }
      if(m_barrin5In.isNew()){
        m_barrin5In.read();
        for(int i=0,len=m_barrin5.data.length(); i<len; i++)
          barrnum[5].push_back(m_barrin5.data[i]);
        flag[5] = true;
      }
      if(m_barrin6In.isNew()){
        m_barrin6In.read();
        for(int i=0,len=m_barrin6.data.length(); i<len; i++)
          barrnum[6].push_back(m_barrin6.data[i]);
        flag[6] = true;
      }
      if(m_barrin7In.isNew()){
        m_barrin7In.read();
        for(int i=0,len=m_barrin7.data.length(); i<len; i++)
          barrnum[7].push_back(m_barrin7.data[i]);
        flag[7] = true;
      }
      if(m_barrin8In.isNew()){
        m_barrin8In.read();
        for(int i=0,len=m_barrin8.data.length(); i<len; i++)
          barrnum[8].push_back(m_barrin8.data[i]);
        flag[8] = true;
      }
      if(m_barrin9In.isNew()){
        m_barrin9In.read();
        for(int i=0,len=m_barrin9.data.length(); i<len; i++)
          barrnum[9].push_back(m_barrin9.data[i]);
        flag[9] = true;
      }
    break;
  }

  if(flag[select-1]){
    m_shortout.data = shortnum[select-1];
    m_shortoutOut.write();
    m_longout.data = longnum[select-1];
    m_longoutOut.write();
    m_floatout.data = floatnum[select-1];
    m_floatoutOut.write();
    m_doubleout.data = doublenum[select-1];
    m_doubleoutOut.write();
    m_boolout.data = boolnum[select-1];
    m_booloutOut.write();

    m_sarrout.data.length(sarrnum[select-1].size());
    for(int i=0, len=sarrnum[select-1].size(); i<len; i++)
      m_sarrout.data[i] = sarrnum[select-1][i];
    m_sarroutOut.write();

    m_larrout.data.length(larrnum[select-1].size());
    for(int i=0, len=larrnum[select-1].size(); i<len; i++)
      m_larrout.data[i] = larrnum[select-1][i];
    m_larroutOut.write();

    m_farrout.data.length(farrnum[select-1].size());
    for(int i=0, len=farrnum[select-1].size(); i<len; i++)
      m_farrout.data[i] = farrnum[select-1][i];
    m_farroutOut.write();

    m_darrout.data.length(darrnum[select-1].size()); 
    for(int i=0, len=darrnum[select-1].size(); i<len; i++)
      m_darrout.data[i] = darrnum[select-1][i];
    m_darroutOut.write();

    m_barrout.data.length(barrnum[select-1].size());
    for(int i=0, len=barrnum[select-1].size(); i<len; i++)
      m_barrout.data[i] = barrnum[select-1][i];
    m_barroutOut.write();
  }

  return RTC::RTC_OK;
}


/*
RTC::ReturnCode_t SelecterIIIO::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t SelecterIIIO::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t SelecterIIIO::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/




extern "C"
{
 
  void SelecterIIIOInit(RTC::Manager* manager)
  {
    RTC::Properties profile(selecteriiio_spec);
    manager->registerFactory(profile,
                             RTC::Create<SelecterIIIO>,
                             RTC::Delete<SelecterIIIO>);
  }
  
};


