// -*- C++ -*-
/*!
 * @file  Summater.cpp
 * @brief Summater component
 * $Date$
 *
 * $Id$
 */

#include "Summater.h"
#include <iostream>

#define SHORT 1
#define LONG 2
#define FLOAT 3
#define DOUBLE 4
#define SHORTARRAY 10
#define LONGARRAY 20
#define FLOATARRAY 30
#define DOUBLEARRAY 40

// Module specification
// <rtc-template block="module_spec">
static const char* summater_spec[] =
  {
    "implementation_id", "Summater",
    "type_name",         "Summater",
    "description",       "Summater component",
    "version",           "1.0",
    "vendor",            "MS_LAB",
    "category",          "",
    "activity_type",     "",
    "max_instance",      "",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables
    "conf.default.DataType", "double",
    "conf.default.InPort_Num", "2",
    "conf.default.Plus_Num", "1",

    ""
  };
// </rtc-template>

Summater::Summater(RTC::Manager* manager)
  : RTC::DataFlowComponentBase(manager),
    // <rtc-template block="initializer">
    m_shortin0In("shortin0", m_shortin0),
    m_shortin1In("shortin1", m_shortin1),
    m_shortin2In("shortin2", m_shortin2),
    m_shortin3In("shortin3", m_shortin3),
    m_shortin4In("shortin4", m_shortin4),
    m_shortin5In("shortin5", m_shortin5),
    m_shortin6In("shortin6", m_shortin6),
    m_shortin7In("shortin7", m_shortin7),
    m_shortin8In("shortin8", m_shortin8),
    m_shortin9In("shortin9", m_shortin9),
    m_longin0In("longin0", m_longin0),
    m_longin1In("longin1", m_longin1),
    m_longin2In("longin2", m_longin2),
    m_longin3In("longin3", m_longin3),
    m_longin4In("longin4", m_longin4),
    m_longin5In("longin5", m_longin5),
    m_longin6In("longin6", m_longin6),
    m_longin7In("longin7", m_longin7),
    m_longin8In("longin8", m_longin8),
    m_longin9In("longin9", m_longin9),
    m_floatin0In("floatin0", m_floatin0),
    m_floatin1In("floatin1", m_floatin1),
    m_floatin2In("floatin2", m_floatin2),
    m_floatin3In("floatin3", m_floatin3),
    m_floatin4In("floatin4", m_floatin4),
    m_floatin5In("floatin5", m_floatin5),
    m_floatin6In("floatin6", m_floatin6),
    m_floatin7In("floatin7", m_floatin7),
    m_floatin8In("floatin8", m_floatin8),
    m_floatin9In("floatin9", m_floatin9),
    m_doublein0In("doublein0", m_doublein0),
    m_doublein1In("doublein1", m_doublein1),
    m_doublein2In("doublein2", m_doublein2),
    m_doublein3In("doublein3", m_doublein3),
    m_doublein4In("doublein4", m_doublein4),
    m_doublein5In("doublein5", m_doublein5),
    m_doublein6In("doublein6", m_doublein6),
    m_doublein7In("doublein7", m_doublein7),
    m_doublein8In("doublein8", m_doublein8),
    m_doublein9In("doublein9", m_doublein9),

    m_sarrin0In("shortarrayin0", m_sarrin0),
    m_sarrin1In("shortarrayin1", m_sarrin1),
    m_sarrin2In("shortarrayin2", m_sarrin2),
    m_sarrin3In("shortarrayin3", m_sarrin3),
    m_sarrin4In("shortarrayin4", m_sarrin4),
    m_sarrin5In("shortarrayin5", m_sarrin5),
    m_sarrin6In("shortarrayin6", m_sarrin6),
    m_sarrin7In("shortarrayin7", m_sarrin7),
    m_sarrin8In("shortarrayin8", m_sarrin8),
    m_sarrin9In("shortarrayin9", m_sarrin9),
    m_larrin0In("longarrayin0", m_larrin0),
    m_larrin1In("longarrayin1", m_larrin1),
    m_larrin2In("longarrayin2", m_larrin2),
    m_larrin3In("longarrayin3", m_larrin3),
    m_larrin4In("longarrayin4", m_larrin4),
    m_larrin5In("longarrayin5", m_larrin5),
    m_larrin6In("longarrayin6", m_larrin6),
    m_larrin7In("longarrayin7", m_larrin7),
    m_larrin8In("longarrayin8", m_larrin8),
    m_larrin9In("longarrayin9", m_larrin9),
    m_farrin0In("floatarrayin0", m_farrin0),
    m_farrin1In("floatarrayin1", m_farrin1),
    m_farrin2In("floatarrayin2", m_farrin2),
    m_farrin3In("floatarrayin3", m_farrin3),
    m_farrin4In("floatarrayin4", m_farrin4),
    m_farrin5In("floatarrayin5", m_farrin5),
    m_farrin6In("floatarrayin6", m_farrin6),
    m_farrin7In("floatarrayin7", m_farrin7),
    m_farrin8In("floatarrayin8", m_farrin8),
    m_farrin9In("floatarrayin9", m_farrin9),
    m_darrin0In("doublearrayin0", m_darrin0),
    m_darrin1In("doublearrayin1", m_darrin1),
    m_darrin2In("doublearrayin2", m_darrin2),
    m_darrin3In("doublearrayin3", m_darrin3),
    m_darrin4In("doublearrayin4", m_darrin4),
    m_darrin5In("doublearrayin5", m_darrin5),
    m_darrin6In("doublearrayin6", m_darrin6),
    m_darrin7In("doublearrayin7", m_darrin7),
    m_darrin8In("doublearrayin8", m_darrin8),
    m_darrin9In("doublearrayin9", m_darrin9),

    m_shortoutOut("shortout", m_shortout),
    m_longoutOut("longout", m_longout),
    m_floatoutOut("floatout", m_floatout),
    m_doubleoutOut("doubleout", m_doubleout),

    m_sarroutOut("shortarrayout", m_sarrout),
    m_larroutOut("longarrayout", m_larrout),
    m_farroutOut("floatarrayout", m_farrout),
    m_darroutOut("doublearrayout", m_darrout),

    m_PrvPortPort("PrvPort"),
    // </rtc-template>
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  //registerInPort("datain", m_datainIn);
  
  // Set OutPort buffer
  //registerOutPort("dataout", m_dataoutOut);
  
  // Set service provider to Ports
  m_PrvPortPort.registerProvider("summater", "summater", m_summater);
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  registerPort(m_PrvPortPort);
  
  // </rtc-template>

}

Summater::~Summater()
{
}


RTC::ReturnCode_t Summater::onInitialize()
{
  // <rtc-template block="bind_config">
  // Bind variables and configuration variable
  bindParameter("DataType", m_DataType, "double");
  bindParameter("InPort_Num", m_InPort_Num, "2");
  bindParameter("Plus_Num", m_Plus_Num, "1");
  
  // </rtc-template>
  std::cout << "Summater start." << std::endl;
  return RTC::RTC_OK;
}




RTC::ReturnCode_t Summater::onFinalize()
{
  RTC::Manager::instance().terminate();
  return RTC::RTC_OK;
}



bool svc_flag=false;
int svc_type=0;
int svc_num=0;
int svc_plus=0;
bool activate_flag=true;

RTC::ReturnCode_t Summater::onActivated(RTC::UniqueId ec_id)
{
  if(activate_flag){

  std::string name[10];

  if(svc_flag)
    type = svc_type;
  else{
    if(m_DataType!="short" && m_DataType!="long" && m_DataType!="float" && m_DataType!="double" && m_DataType!="shortArray" && m_DataType!="longArray" && m_DataType!="floatArray" && m_DataType!="doubleArray"){
      std::cout << "DataType ERROR" << std::endl;
      return RTC::RTC_ERROR;
    }
    if(m_DataType=="short")
      type = SHORT;
    else if(m_DataType=="long")
      type = LONG;
    else if(m_DataType=="float")
      type = FLOAT;
    else if(m_DataType=="double")
      type = DOUBLE;
    else if(m_DataType=="shortArray")
      type = SHORTARRAY;
    else if(m_DataType=="longArray")
      type = LONGARRAY;
    else if(m_DataType=="floatArray")
      type = FLOATARRAY;
    else if(m_DataType=="doubleArray")
      type = DOUBLEARRAY;
  }


  if(svc_flag)
    num = svc_num;
  else
    num = m_InPort_Num;

  if(num < 1 || 10 < num){
    std::cout << "InPort_Num ERROR" << std::endl;
    return RTC::RTC_ERROR;
  }


  if(svc_flag)
    plus = svc_plus;
  else
    plus = m_Plus_Num;

  if(num < plus){
    std::cout << "Minus_Num ERROR" << std::endl;
    return RTC::RTC_ERROR;
  }


  for(int i=0; i<10; i++){
    name[i] = "in";
  }

  for(int i=0; i<plus; i++){
    name[i] += otos(i);
    name[i] += "+";
  }
  for(int i=0; i<num-plus; i++){
      name[i+plus] += otos(i);
      name[i+plus] += "-";
  }

  switch(type){
    case SHORT:
      registerOutPort("shortout", m_shortoutOut);

      for(int i=0; i<num; i++)
          name[i] = "short" + name[i];
      if(num > 0)
        registerInPort(name[0].c_str(), m_shortin0In);
      if(num > 1)
        registerInPort(name[1].c_str(), m_shortin1In);
      if(num > 2)
        registerInPort(name[2].c_str(), m_shortin2In);
      if(num > 3)
        registerInPort(name[3].c_str(), m_shortin3In);
      if(num > 4)
        registerInPort(name[4].c_str(), m_shortin4In);
      if(num > 5)
        registerInPort(name[5].c_str(), m_shortin5In);
      if(num > 6)
        registerInPort(name[6].c_str(), m_shortin6In);
      if(num > 7)
        registerInPort(name[7].c_str(), m_shortin7In);
      if(num > 8)
        registerInPort(name[8].c_str(), m_shortin8In);
      if(num > 9)
        registerInPort(name[9].c_str(), m_shortin9In);
    break;

    case LONG:
      registerOutPort("longout", m_longoutOut);

      for(int i=0; i<num; i++)
          name[i] = "long" + name[i];
      if(num > 0)
        registerInPort(name[0].c_str(), m_longin0In);
      if(num > 1)
        registerInPort(name[1].c_str(), m_longin1In);
      if(num > 2)
        registerInPort(name[2].c_str(), m_longin2In);
      if(num > 3)
        registerInPort(name[3].c_str(), m_longin3In);
      if(num > 4)
        registerInPort(name[4].c_str(), m_longin4In);
      if(num > 5)
        registerInPort(name[5].c_str(), m_longin5In);
      if(num > 6)
        registerInPort(name[6].c_str(), m_longin6In);
      if(num > 7)
        registerInPort(name[7].c_str(), m_longin7In);
      if(num > 8)
        registerInPort(name[8].c_str(), m_longin8In);
      if(num > 9)
        registerInPort(name[9].c_str(), m_longin9In);
    break;

    case FLOAT:
      registerOutPort("floatout", m_floatoutOut);

      for(int i=0; i<num; i++)
          name[i] = "float" + name[i];
      if(num > 0)
        registerInPort(name[0].c_str(), m_floatin0In);
      if(num > 1)
        registerInPort(name[1].c_str(), m_floatin1In);
      if(num > 2)
        registerInPort(name[2].c_str(), m_floatin2In);
      if(num > 3)
        registerInPort(name[3].c_str(), m_floatin3In);
      if(num > 4)
        registerInPort(name[4].c_str(), m_floatin4In);
      if(num > 5)
        registerInPort(name[5].c_str(), m_floatin5In);
      if(num > 6)
        registerInPort(name[6].c_str(), m_floatin6In);
      if(num > 7)
        registerInPort(name[7].c_str(), m_floatin7In);
      if(num > 8)
        registerInPort(name[8].c_str(), m_floatin8In);
      if(num > 9)
        registerInPort(name[9].c_str(), m_floatin9In);
    break;

    case DOUBLE:
      registerOutPort("doubleout", m_doubleoutOut);

      for(int i=0; i<num; i++)
          name[i] = "double" + name[i];
      if(num > 0)
        registerInPort(name[0].c_str(), m_doublein0In);
      if(num > 1)
        registerInPort(name[1].c_str(), m_doublein1In);
      if(num > 2)
        registerInPort(name[2].c_str(), m_doublein2In);
      if(num > 3)
        registerInPort(name[3].c_str(), m_doublein3In);
      if(num > 4)
        registerInPort(name[4].c_str(), m_doublein4In);
      if(num > 5)
        registerInPort(name[5].c_str(), m_doublein5In);
      if(num > 6)
        registerInPort(name[6].c_str(), m_doublein6In);
      if(num > 7)
        registerInPort(name[7].c_str(), m_doublein7In);
      if(num > 8)
        registerInPort(name[8].c_str(), m_doublein8In);
      if(num > 9)
        registerInPort(name[9].c_str(), m_doublein9In);
    break;

    case SHORTARRAY:
      registerOutPort("shortArrayout", m_sarroutOut);

      for(int i=0; i<num; i++)
          name[i] = "shortArray" + name[i];
      if(num > 0)
        registerInPort(name[0].c_str(), m_sarrin0In);
      if(num > 1)
        registerInPort(name[1].c_str(), m_sarrin1In);
      if(num > 2)
        registerInPort(name[2].c_str(), m_sarrin2In);
      if(num > 3)
        registerInPort(name[3].c_str(), m_sarrin3In);
      if(num > 4)
        registerInPort(name[4].c_str(), m_sarrin4In);
      if(num > 5)
        registerInPort(name[5].c_str(), m_sarrin5In);
      if(num > 6)
        registerInPort(name[6].c_str(), m_sarrin6In);
      if(num > 7)
        registerInPort(name[7].c_str(), m_sarrin7In);
      if(num > 8)
        registerInPort(name[8].c_str(), m_sarrin8In);
      if(num > 9)
        registerInPort(name[9].c_str(), m_sarrin9In);
    break;

    case LONGARRAY:
      registerOutPort("longArrayout", m_larroutOut);

      for(int i=0; i<num; i++)
          name[i] = "longArray" + name[i];
      if(num > 0)
        registerInPort(name[0].c_str(), m_larrin0In);
      if(num > 1)
        registerInPort(name[1].c_str(), m_larrin1In);
      if(num > 2)
        registerInPort(name[2].c_str(), m_larrin2In);
      if(num > 3)
        registerInPort(name[3].c_str(), m_larrin3In);
      if(num > 4)
        registerInPort(name[4].c_str(), m_larrin4In);
      if(num > 5)
        registerInPort(name[5].c_str(), m_larrin5In);
      if(num > 6)
        registerInPort(name[6].c_str(), m_larrin6In);
      if(num > 7)
        registerInPort(name[7].c_str(), m_larrin7In);
      if(num > 8)
        registerInPort(name[8].c_str(), m_larrin8In);
      if(num > 9)
        registerInPort(name[9].c_str(), m_larrin9In);
    break;

    case FLOATARRAY:
      registerOutPort("floatArrayout", m_farroutOut);

      for(int i=0; i<num; i++)
          name[i] = "floatArray" + name[i];
      if(num > 0)
        registerInPort(name[0].c_str(), m_farrin0In);
      if(num > 1)
        registerInPort(name[1].c_str(), m_farrin1In);
      if(num > 2)
        registerInPort(name[2].c_str(), m_farrin2In);
      if(num > 3)
        registerInPort(name[3].c_str(), m_farrin3In);
      if(num > 4)
        registerInPort(name[4].c_str(), m_farrin4In);
      if(num > 5)
        registerInPort(name[5].c_str(), m_farrin5In);
      if(num > 6)
        registerInPort(name[6].c_str(), m_farrin6In);
      if(num > 7)
        registerInPort(name[7].c_str(), m_farrin7In);
      if(num > 8)
        registerInPort(name[8].c_str(), m_farrin8In);
      if(num > 9)
        registerInPort(name[9].c_str(), m_farrin9In);
    break;

    case DOUBLEARRAY:
      registerOutPort("doubleArrayout", m_darroutOut);

      for(int i=0; i<num; i++)
          name[i] = "doubleArray" + name[i];
      if(num > 0)
        registerInPort(name[0].c_str(), m_darrin0In);
      if(num > 1)
        registerInPort(name[1].c_str(), m_darrin1In);
      if(num > 2)
        registerInPort(name[2].c_str(), m_darrin2In);
      if(num > 3)
        registerInPort(name[3].c_str(), m_darrin3In);
      if(num > 4)
        registerInPort(name[4].c_str(), m_darrin4In);
      if(num > 5)
        registerInPort(name[5].c_str(), m_darrin5In);
      if(num > 6)
        registerInPort(name[6].c_str(), m_darrin6In);
      if(num > 7)
        registerInPort(name[7].c_str(), m_darrin7In);
      if(num > 8)
        registerInPort(name[8].c_str(), m_darrin8In);
      if(num > 9)
        registerInPort(name[9].c_str(), m_darrin9In);
    break;
  }

  activate_flag=false;
  }

  return RTC::RTC_OK;
}


bool flag[10]={false, false, false, false, false, false, false, false, false, false};
short shortnum[10] = {0};
long longnum[10] = {0};
float floatnum[10] = {0};
double doublenum[10] = {0};
std::vector<short>  sarrnum[10];
std::vector<long>   larrnum[10];
std::vector<float>  farrnum[10];
std::vector<double> darrnum[10];

RTC::ReturnCode_t Summater::onDeactivated(RTC::UniqueId ec_id)
{
  for(int i=0; i<10; i++){
    sarrnum[i].clear();
    larrnum[i].clear();
    farrnum[i].clear();
    darrnum[i].clear();
    flag[i] = false;
    shortnum[i] = 0;
    longnum[i] = 0;
    floatnum[i] = 0;
    doublenum[i] = 0;
  }
  m_shortin0In.read();
  m_shortin1In.read();
  m_shortin2In.read();
  m_shortin3In.read();
  m_shortin4In.read();
  m_shortin5In.read();
  m_shortin6In.read();
  m_shortin7In.read();
  m_shortin8In.read();
  m_shortin9In.read();
  m_longin0In.read();
  m_longin1In.read();
  m_longin2In.read();
  m_longin3In.read();
  m_longin4In.read();
  m_longin5In.read();
  m_longin6In.read();
  m_longin7In.read();
  m_longin8In.read();
  m_longin9In.read();
  m_floatin0In.read();
  m_floatin1In.read();
  m_floatin2In.read();
  m_floatin3In.read();
  m_floatin4In.read();
  m_floatin5In.read();
  m_floatin6In.read();
  m_floatin7In.read();
  m_floatin8In.read();
  m_floatin9In.read();
  m_doublein0In.read();
  m_doublein1In.read();
  m_doublein2In.read();
  m_doublein3In.read();
  m_doublein4In.read();
  m_doublein5In.read();
  m_doublein6In.read();
  m_doublein7In.read();
  m_doublein8In.read();
  m_doublein9In.read();
  m_sarrin0In.read();
  m_sarrin1In.read();
  m_sarrin2In.read();
  m_sarrin3In.read();
  m_sarrin4In.read();
  m_sarrin5In.read();
  m_sarrin6In.read();
  m_sarrin7In.read();
  m_sarrin8In.read();
  m_sarrin9In.read();
  m_larrin0In.read();
  m_larrin1In.read();
  m_larrin2In.read();
  m_larrin3In.read();
  m_larrin4In.read();
  m_larrin5In.read();
  m_larrin6In.read();
  m_larrin7In.read();
  m_larrin8In.read();
  m_larrin9In.read();
  m_farrin0In.read();
  m_farrin1In.read();
  m_farrin2In.read();
  m_farrin3In.read();
  m_farrin4In.read();
  m_farrin5In.read();
  m_farrin6In.read();
  m_farrin7In.read();
  m_farrin8In.read();
  m_farrin9In.read();
  m_darrin0In.read();
  m_darrin1In.read();
  m_darrin2In.read();
  m_darrin3In.read();
  m_darrin4In.read();
  m_darrin5In.read();
  m_darrin6In.read();
  m_darrin7In.read();
  m_darrin8In.read();
  m_darrin9In.read();

  return RTC::RTC_OK;
}



RTC::ReturnCode_t Summater::onExecute(RTC::UniqueId ec_id)
{
  bool all_read_flag=false;
  short shortsum=0;
  long longsum=0;
  float floatsum=0;
  double doublesum=0;
  static int selement[10] = {0}, lelement[10] = {0}, felement[10] = {0}, delement[10] = {0};
  static int smaxelement=0, lmaxelement=0, fmaxelement=0, dmaxelement=0;
  std::vector<short>  sarrsum;
  std::vector<long>   larrsum;
  std::vector<float>  farrsum;
  std::vector<double> darrsum;

  if(num >= 1){
    if(m_shortin0In.isNew()){
      m_shortin0In.read();
      shortnum[0] = m_shortin0.data;
      flag[0] = true;
    }
    if(m_longin0In.isNew()){
      m_longin0In.read();
      longnum[0] = m_longin0.data;
      flag[0] = true;
    }
    if(m_floatin0In.isNew()){
      m_floatin0In.read();
      floatnum[0] = m_floatin0.data;
      flag[0] = true;
    }
    if(m_doublein0In.isNew()){
      m_doublein0In.read();
      doublenum[0] = m_doublein0.data;
      flag[0] = true;
    }
    if(m_sarrin0In.isNew()){
      m_sarrin0In.read();
      selement[0] = m_sarrin0.data.length();
      for(int i=0; sarrnum[0].size()<=selement[0]; i++)
        sarrnum[0].push_back(0);
      for(int i=0; i<selement[0]; i++)
        sarrnum[0][i] = m_sarrin0.data[i];
      flag[0] = true;
    }
    if(m_larrin0In.isNew()){
      m_larrin0In.read();
      lelement[0] = m_larrin0.data.length();
      for(int i=0; larrnum[0].size()<=lelement[0]; i++)
        larrnum[0].push_back(0);
      for(int i=0; i<lelement[0]; i++)
        larrnum[0][i] = m_larrin0.data[i];
      flag[0] = true;
    }
    if(m_farrin0In.isNew()){
      m_farrin0In.read();
      felement[0] = m_farrin0.data.length();
      for(int i=0; farrnum[0].size()<=felement[0]; i++)
        farrnum[0].push_back(0);
      for(int i=0; i<felement[0]; i++)
        farrnum[0][i] = m_farrin0.data[i];
      flag[0] = true;
    }
    if(m_darrin0In.isNew()){
      m_darrin0In.read();
      delement[0] = m_darrin0.data.length();
      for(int i=0; darrnum[0].size()<=delement[0]; i++)
        darrnum[0].push_back(0);
      for(int i=0; i<delement[0]; i++)
        darrnum[0][i] = m_darrin0.data[i];
      flag[0] = true;
    }
  }
  if(num >= 2){
    if(m_shortin1In.isNew()){
      m_shortin1In.read();
      shortnum[1] = m_shortin1.data;
      flag[1] = true;
    }
    if(m_longin1In.isNew()){
      m_longin1In.read();
      longnum[1] = m_longin1.data;
      flag[1] = true;
    }
    if(m_floatin1In.isNew()){
      m_floatin1In.read();
      floatnum[1] = m_floatin1.data;
      flag[1] = true;
    }
    if(m_doublein1In.isNew()){
      m_doublein1In.read();
      doublenum[1] = m_doublein1.data;
      flag[1] = true;
    }
    if(m_sarrin1In.isNew()){
      m_sarrin1In.read();
      selement[1] = m_sarrin1.data.length();
      for(int i=0; sarrnum[1].size()<=selement[1]; i++)
        sarrnum[1].push_back(0);
      for(int i=0; i<selement[1]; i++)
        sarrnum[1][i] = m_sarrin1.data[i];
      flag[1] = true;
    }
    if(m_larrin1In.isNew()){
      m_larrin1In.read();
      lelement[1] = m_larrin1.data.length();
      for(int i=0; larrnum[1].size()<=lelement[1]; i++)
        larrnum[1].push_back(0);
      for(int i=0; i<lelement[1]; i++)
        larrnum[1][i] = m_larrin1.data[i];
      flag[1] = true;
    }
    if(m_farrin1In.isNew()){
      m_farrin1In.read();
      felement[1] = m_farrin1.data.length();
      for(int i=0; farrnum[1].size()<=felement[1]; i++)
        farrnum[1].push_back(0);
      for(int i=0; i<felement[1]; i++)
        farrnum[1][i] = m_farrin1.data[i];
      flag[1] = true;
    }
    if(m_darrin1In.isNew()){
      m_darrin1In.read();
      delement[1] = m_darrin1.data.length();
      for(int i=0; darrnum[1].size()<=delement[1]; i++)
        darrnum[1].push_back(0);
      for(int i=0; i<delement[1]; i++)
        darrnum[1][i] = m_darrin1.data[i];
      flag[1] = true;
    }
  }
  if(num >= 3){
    if(m_shortin2In.isNew()){
      m_shortin2In.read();
      shortnum[2] = m_shortin2.data;
      flag[2] = true;
    }
    if(m_longin2In.isNew()){
      m_longin2In.read();
      longnum[2] = m_longin2.data;
      flag[2] = true;
    }
    if(m_floatin2In.isNew()){
      m_floatin2In.read();
      floatnum[2] = m_floatin2.data;
      flag[2] = true;
    }
    if(m_doublein2In.isNew()){
      m_doublein2In.read();
      doublenum[2] = m_doublein2.data;
      flag[2] = true;
    }
    if(m_sarrin2In.isNew()){
      m_sarrin2In.read();
      selement[2] = m_sarrin2.data.length();
      for(int i=0; sarrnum[2].size()<=selement[2]; i++)
        sarrnum[2].push_back(0);
      for(int i=0; i<selement[2]; i++)
        sarrnum[2][i] = m_sarrin2.data[i];
      flag[2] = true;
    }
    if(m_larrin2In.isNew()){
      m_larrin2In.read();
      lelement[2] = m_larrin2.data.length();
      for(int i=0; larrnum[2].size()<=lelement[2]; i++)
        larrnum[2].push_back(0);
      for(int i=0; i<lelement[2]; i++)
        larrnum[2][i] = m_larrin2.data[i];
      flag[2] = true;
    }
    if(m_farrin2In.isNew()){
      m_farrin2In.read();
      felement[2] = m_farrin2.data.length();
      for(int i=0; farrnum[2].size()<=felement[2]; i++)
        farrnum[2].push_back(0);
      for(int i=0; i<felement[2]; i++)
        farrnum[2][i] = m_farrin2.data[i];
      flag[2] = true;
    }
    if(m_darrin2In.isNew()){
      m_darrin2In.read();
      delement[2] = m_darrin2.data.length();
      for(int i=0; darrnum[2].size()<=delement[2]; i++)
        darrnum[2].push_back(0);
      for(int i=0; i<delement[2]; i++)
        darrnum[2][i] = m_darrin2.data[i];
      flag[2] = true;
    }
  }
  if(num >= 4){
    if(m_shortin3In.isNew()){
      m_shortin3In.read();
      shortnum[3] = m_shortin3.data;
      flag[3] = true;
    }
    if(m_longin3In.isNew()){
      m_longin3In.read();
      longnum[3] = m_longin3.data;
      flag[3] = true;
    }
    if(m_floatin3In.isNew()){
      m_floatin3In.read();
      floatnum[3] = m_floatin3.data;
      flag[3] = true;
    }
    if(m_doublein3In.isNew()){
      m_doublein3In.read();
      doublenum[3] = m_doublein3.data;
      flag[3] = true;
    }
    if(m_sarrin3In.isNew()){
      m_sarrin3In.read();
      selement[3] = m_sarrin3.data.length();
      for(int i=0; sarrnum[3].size()<=selement[3]; i++)
        sarrnum[3].push_back(0);
      for(int i=0; i<selement[3]; i++)
        sarrnum[3][i] = m_sarrin3.data[i];
      flag[3] = true;
    }
    if(m_larrin3In.isNew()){
      m_larrin3In.read();
      lelement[3] = m_larrin3.data.length();
      for(int i=0; larrnum[3].size()<=lelement[3]; i++)
        larrnum[3].push_back(0);
      for(int i=0; i<lelement[3]; i++)
        larrnum[3][i] = m_larrin3.data[i];
      flag[3] = true;
    }
    if(m_farrin3In.isNew()){
      m_farrin3In.read();
      felement[3] = m_farrin3.data.length();
      for(int i=0; farrnum[3].size()<=felement[3]; i++)
        farrnum[3].push_back(0);
      for(int i=0; i<felement[3]; i++)
        farrnum[3][i] = m_farrin3.data[i];
      flag[3] = true;
    }
    if(m_darrin3In.isNew()){
      m_darrin3In.read();
      delement[3] = m_darrin3.data.length();
      for(int i=0; darrnum[3].size()<=delement[3]; i++)
        darrnum[3].push_back(0);
      for(int i=0; i<delement[3]; i++)
        darrnum[3][i] = m_darrin3.data[i];
      flag[3] = true;
    }
  }

  if(num >= 5){
    if(m_shortin4In.isNew()){
      m_shortin4In.read();
      shortnum[4] = m_shortin4.data;
      flag[4] = true;
    }
    if(m_longin4In.isNew()){
      m_longin4In.read();
      longnum[4] = m_longin4.data;
      flag[4] = true;
    }
    if(m_floatin4In.isNew()){
      m_floatin4In.read();
      floatnum[4] = m_floatin4.data;
      flag[4] = true;
    }
    if(m_doublein4In.isNew()){
      m_doublein4In.read();
      doublenum[4] = m_doublein4.data;
      flag[4] = true;
    }
    if(m_sarrin4In.isNew()){
      m_sarrin4In.read();
      selement[4] = m_sarrin4.data.length();
      for(int i=0; sarrnum[4].size()<=selement[4]; i++)
        sarrnum[4].push_back(0);
      for(int i=0; i<selement[4]; i++)
        sarrnum[4][i] = m_sarrin4.data[i];
      flag[4] = true;
    }
    if(m_larrin4In.isNew()){
      m_larrin4In.read();
      lelement[4] = m_larrin4.data.length();
      for(int i=0; larrnum[4].size()<=lelement[4]; i++)
        larrnum[4].push_back(0);
      for(int i=0; i<lelement[4]; i++)
        larrnum[4][i] = m_larrin4.data[i];
      flag[4] = true;
    }
    if(m_farrin4In.isNew()){
      m_farrin4In.read();
      felement[4] = m_farrin4.data.length();
      for(int i=0; farrnum[4].size()<=felement[4]; i++)
        farrnum[4].push_back(0);
      for(int i=0; i<felement[4]; i++)
        farrnum[4][i] = m_farrin4.data[i];
      flag[4] = true;
    }
    if(m_darrin4In.isNew()){
      m_darrin4In.read();
      delement[4] = m_darrin4.data.length();
      for(int i=0; darrnum[4].size()<=delement[4]; i++)
        darrnum[4].push_back(0);
      for(int i=0; i<delement[4]; i++)
        darrnum[4][i] = m_darrin4.data[i];
      flag[4] = true;
    }
  }

  if(num >= 6){
    if(m_shortin5In.isNew()){
      m_shortin5In.read();
      shortnum[5] = m_shortin5.data;
      flag[5] = true;
    }
    if(m_longin5In.isNew()){
      m_longin5In.read();
      longnum[5] = m_longin5.data;
      flag[5] = true;
    }
    if(m_floatin5In.isNew()){
      m_floatin5In.read();
      floatnum[5] = m_floatin5.data;
      flag[5] = true;
    }
    if(m_doublein5In.isNew()){
      m_doublein5In.read();
      doublenum[5] = m_doublein5.data;
      flag[5] = true;
    }
    if(m_sarrin5In.isNew()){
      m_sarrin5In.read();
      selement[5] = m_sarrin5.data.length();
      for(int i=0; sarrnum[5].size()<=selement[5]; i++)
        sarrnum[5].push_back(0);
      for(int i=0; i<selement[5]; i++)
        sarrnum[5][i] = m_sarrin5.data[i];
      flag[5] = true;
    }
    if(m_larrin5In.isNew()){
      m_larrin5In.read();
      lelement[5] = m_larrin5.data.length();
      for(int i=0; larrnum[5].size()<=lelement[5]; i++)
        larrnum[5].push_back(0);
      for(int i=0; i<lelement[5]; i++)
        larrnum[5][i] = m_larrin5.data[i];
      flag[5] = true;
    }
    if(m_farrin5In.isNew()){
      m_farrin5In.read();
      felement[5] = m_farrin5.data.length();
      for(int i=0; farrnum[5].size()<=felement[5]; i++)
        farrnum[5].push_back(0);
      for(int i=0; i<felement[5]; i++)
        farrnum[5][i] = m_farrin5.data[i];
      flag[5] = true;
    }
    if(m_darrin5In.isNew()){
      m_darrin5In.read();
      delement[5] = m_darrin5.data.length();
      for(int i=0; darrnum[5].size()<=delement[5]; i++)
        darrnum[5].push_back(0);
      for(int i=0; i<delement[5]; i++)
        darrnum[5][i] = m_darrin5.data[i];
      flag[5] = true;
    }
  }

  if(num >= 7){
    if(m_shortin6In.isNew()){
      m_shortin6In.read();
      shortnum[6] = m_shortin6.data;
      flag[6] = true;
    }
    if(m_longin6In.isNew()){
      m_longin6In.read();
      longnum[6] = m_longin6.data;
      flag[6] = true;
    }
    if(m_floatin6In.isNew()){
      m_floatin6In.read();
      floatnum[6] = m_floatin6.data;
      flag[6] = true;
    }
    if(m_doublein6In.isNew()){
      m_doublein6In.read();
      doublenum[6] = m_doublein6.data;
      flag[6] = true;
    }
    if(m_sarrin6In.isNew()){
      m_sarrin6In.read();
      selement[6] = m_sarrin6.data.length();
      for(int i=0; sarrnum[6].size()<=selement[6]; i++)
        sarrnum[6].push_back(0);
      for(int i=0; i<selement[6]; i++)
        sarrnum[6][i] = m_sarrin6.data[i];
      flag[6] = true;
    }
    if(m_larrin6In.isNew()){
      m_larrin6In.read();
      lelement[6] = m_larrin6.data.length();
      for(int i=0; larrnum[6].size()<=lelement[6]; i++)
        larrnum[6].push_back(0);
      for(int i=0; i<lelement[6]; i++)
        larrnum[6][i] = m_larrin6.data[i];
      flag[6] = true;
    }
    if(m_farrin6In.isNew()){
      m_farrin6In.read();
      felement[6] = m_farrin6.data.length();
      for(int i=0; farrnum[6].size()<=lelement[6]; i++)
        larrnum[6].push_back(0);
      for(int i=0; i<lelement[6]; i++)
        larrnum[6][i] = m_larrin6.data[i];
      flag[6] = true;
    }
    if(m_darrin6In.isNew()){
      m_darrin6In.read();
      delement[6] = m_darrin6.data.length();
      for(int i=0; darrnum[6].size()<=delement[6]; i++)
        darrnum[6].push_back(0);
      for(int i=0; i<delement[6]; i++)
        darrnum[6][i] = m_darrin6.data[i];
      flag[6] = true;
    }
  }

  if(num >= 8){
    if(m_shortin7In.isNew()){
      m_shortin7In.read();
      shortnum[7] = m_shortin7.data;
      flag[7] = true;
    }
    if(m_longin7In.isNew()){
      m_longin7In.read();
      longnum[7] = m_longin7.data;
      flag[7] = true;
    }
    if(m_floatin7In.isNew()){
      m_floatin7In.read();
      floatnum[7] = m_floatin7.data;
      flag[7] = true;
    }
    if(m_doublein7In.isNew()){
      m_doublein7In.read();
      doublenum[7] = m_doublein7.data;
      flag[7] = true;
    }
    if(m_sarrin7In.isNew()){
      m_sarrin7In.read();
      selement[7] = m_sarrin7.data.length();
      for(int i=0; sarrnum[7].size()<=selement[7]; i++)
        sarrnum[7].push_back(0);
      for(int i=0; i<selement[7]; i++)
        sarrnum[7][i] = m_sarrin7.data[i];
      flag[7] = true;
    }
    if(m_larrin7In.isNew()){
      m_larrin7In.read();
      lelement[7] = m_larrin7.data.length();
      for(int i=0; larrnum[7].size()<=lelement[7]; i++)
        larrnum[7].push_back(0);
      for(int i=0; i<lelement[7]; i++)
        larrnum[7][i] = m_larrin7.data[i];
      flag[7] = true;
    }
    if(m_farrin7In.isNew()){
      m_farrin7In.read();
      felement[7] = m_farrin7.data.length();
      for(int i=0; farrnum[7].size()<=felement[7]; i++)
        farrnum[7].push_back(0);
      for(int i=0; i<felement[7]; i++)
        farrnum[7][i] = m_farrin7.data[i];
      flag[7] = true;
    }
    if(m_darrin7In.isNew()){
      m_darrin7In.read();
      delement[7] = m_darrin7.data.length();
      for(int i=0; darrnum[7].size()<=delement[7]; i++)
        darrnum[7].push_back(0);
      for(int i=0; i<delement[7]; i++)
        darrnum[7][i] = m_darrin7.data[i];
      flag[7] = true;
    }
  }
  
  if(num >= 9){
    if(m_shortin8In.isNew()){
      m_shortin8In.read();
      shortnum[8] = m_shortin8.data;
      flag[8] = true;
    }
    if(m_longin8In.isNew()){
      m_longin8In.read();
      longnum[8] = m_longin8.data;
      flag[8] = true;
    }
    if(m_floatin8In.isNew()){
      m_floatin8In.read();
      floatnum[8] = m_floatin8.data;
      flag[8] = true;
    }
    if(m_doublein8In.isNew()){
      m_doublein8In.read();
      doublenum[8] = m_doublein8.data;
      flag[8] = true;
    }
    if(m_sarrin8In.isNew()){
      m_sarrin8In.read();
      selement[8] = m_sarrin8.data.length();
      for(int i=0; sarrnum[8].size()<=selement[8]; i++)
        sarrnum[8].push_back(0);
      for(int i=0; i<selement[8]; i++)
        sarrnum[8][i] = m_sarrin8.data[i];
      flag[8] = true;
    }
    if(m_larrin8In.isNew()){
      m_larrin8In.read();
      lelement[8] = m_larrin8.data.length();
      for(int i=0; larrnum[8].size()<=lelement[8]; i++)
        larrnum[8].push_back(0);
      for(int i=0; i<lelement[8]; i++)
        larrnum[8][i] = m_larrin8.data[i];
      flag[8] = true;
    }
    if(m_farrin8In.isNew()){
      m_farrin8In.read();
      felement[8] = m_farrin8.data.length();
      for(int i=0; farrnum[8].size()<=felement[8]; i++)
        farrnum[8].push_back(0);
      for(int i=0; i<felement[8]; i++)
        farrnum[8][i] = m_farrin8.data[i];
      flag[8] = true;
    }
    if(m_darrin8In.isNew()){
      m_darrin8In.read();
      delement[8] = m_darrin8.data.length();
      for(int i=0; darrnum[8].size()<=delement[8]; i++)
        darrnum[8].push_back(0);
      for(int i=0; i<delement[8]; i++)
        darrnum[8][i] = m_darrin8.data[i];
      flag[8] = true;
    }
  }

  if(num >= 10){
    if(m_shortin9In.isNew()){
      m_shortin9In.read();
      shortnum[9] = m_shortin9.data;
      flag[9] = true;
    }
    if(m_longin9In.isNew()){
      m_longin9In.read();
      longnum[9] = m_longin9.data;
      flag[9] = true;
    }
    if(m_floatin9In.isNew()){
      m_floatin9In.read();
      floatnum[9] = m_floatin9.data;
      flag[9] = true;
    }
    if(m_doublein9In.isNew()){
      m_doublein9In.read();
      doublenum[9] = m_doublein9.data;
      flag[9] = true;
    }
    if(m_sarrin9In.isNew()){
      m_sarrin9In.read();
      selement[9] = m_sarrin9.data.length();
      for(int i=0; sarrnum[9].size()<=selement[9]; i++)
        sarrnum[9].push_back(0);
      for(int i=0; i<selement[9]; i++)
        sarrnum[9][i] = m_sarrin9.data[i];
      flag[9] = true;
    }
    if(m_larrin9In.isNew()){
      m_larrin9In.read();
      lelement[9] = m_larrin9.data.length();
      for(int i=0; larrnum[9].size()<=lelement[9]; i++)
        larrnum[9].push_back(0);
      for(int i=0; i<lelement[9]; i++)
        larrnum[9][i] = m_larrin9.data[i];
      flag[9] = true;
    }
    if(m_farrin9In.isNew()){
      m_farrin9In.read();
      felement[9] = m_farrin9.data.length();
      for(int i=0; farrnum[9].size()<=felement[9]; i++)
        farrnum[9].push_back(0);
      for(int i=0; i<felement[9]; i++)
        farrnum[9][i] = m_farrin9.data[i];
      flag[9] = true;
    }
    if(m_darrin9In.isNew()){
      m_darrin9In.read();
      delement[9] = m_darrin9.data.length();
      for(int i=0; darrnum[9].size()<=delement[9]; i++)
        darrnum[9].push_back(0);
      for(int i=0; i<delement[9]; i++)
        darrnum[9][i] = m_darrin9.data[i];
      flag[9] = true;
    }
  }

  all_read_flag = true;
  for(int i=0; i<num; i++){
    if(flag[i] == false)
      all_read_flag = false;
  }

  if(all_read_flag == true){
    switch(type){
      case SHORT:
        for(int i=0; i<plus; i++)
          shortsum += shortnum[i];
        for(int i=plus; i<num; i++)
          shortsum -= shortnum[i];
        m_shortout.data = shortsum;
        m_shortoutOut.write();
      break;

      case LONG:
        for(int i=0; i<plus; i++)
          longsum += longnum[i];
        for(int i=plus; i<num; i++)
          longsum -= longnum[i];
        m_longout.data = longsum;
        m_longoutOut.write();
      break;

      case FLOAT:
        for(int i=0; i<plus; i++)
          floatsum += floatnum[i];
        for(int i=plus; i<num; i++)
          floatsum -= floatnum[i];
        m_floatout.data = floatsum;
        m_floatoutOut.write();
      break;
 
      case DOUBLE:
        for(int i=0; i<plus; i++)
          doublesum += doublenum[i];
        for(int i=plus; i<num; i++)
          doublesum -= doublenum[i];
        m_doubleout.data = doublesum;
        m_doubleoutOut.write();
      break;
 
      case SHORTARRAY:
        for(int i=0; i<10; i++){
          if(selement[i] > smaxelement)
            smaxelement = selement[i];
        }
        for(int i=0; i<smaxelement; i++)
          sarrsum.push_back(0);
        for(int i=0; i<plus; i++){
          for(int j=0; j<selement[i]; j++)
            sarrsum[j] += sarrnum[i][j];
        }
        for(int i=plus; i<num; i++){
          for(int j=0; j<selement[i]; j++)
            sarrsum[j] -= sarrnum[i][j];
        }
        m_sarrout.data.length(smaxelement);
        for(int i=0; i<smaxelement; i++)
          m_sarrout.data[i] = sarrsum[i];
        m_sarroutOut.write();
      break;

      case LONGARRAY:
        for(int i=0; i<10; i++){
          if(lelement[i] > lmaxelement)
            lmaxelement = lelement[i];
        }
        for(int i=0; i<lmaxelement; i++)
          larrsum.push_back(0);
        for(int i=0; i<plus; i++){
          for(int j=0; j<lelement[i]; j++)
            larrsum[j] += larrnum[i][j];
        }
        for(int i=plus; i<num; i++){
          for(int j=0; j<lelement[i]; j++)
            larrsum[j] -= larrnum[i][j];
        }
        m_larrout.data.length(lmaxelement);
        for(int i=0; i<lmaxelement; i++)
          m_larrout.data[i] = larrsum[i];
        m_larroutOut.write();
      break;

      case FLOATARRAY:
        for(int i=0; i<10; i++){
          if(felement[i] > fmaxelement)
            fmaxelement = felement[i];
        }
        for(int i=0; i<fmaxelement; i++)
          farrsum.push_back(0);
        for(int i=0; i<plus; i++){
          for(int j=0; j<felement[i]; j++)
            farrsum[j] += farrnum[i][j];
        }
        for(int i=plus; i<num; i++){
          for(int j=0; j<felement[i]; j++)
            farrsum[j] -= farrnum[i][j];
        }
        m_farrout.data.length(fmaxelement);
        for(int i=0; i<fmaxelement; i++)
          m_farrout.data[i] = farrsum[i];
        m_farroutOut.write();
      break;

      case DOUBLEARRAY:
        for(int i=0; i<10; i++){
          if(delement[i] > dmaxelement)
            dmaxelement = delement[i];
        }
        for(int i=0; i<dmaxelement; i++)
          darrsum.push_back(0);
        for(int i=0; i<plus; i++){
          for(int j=0; j<delement[i]; j++)
            darrsum[j] += darrnum[i][j];
        }
        for(int i=plus; i<num; i++){
          for(int j=0; j<delement[i]; j++)
            darrsum[j] -= darrnum[i][j];
        }
        m_darrout.data.length(dmaxelement);
        for(int i=0; i<dmaxelement; i++)
          m_darrout.data[i] = darrsum[i];
        m_darroutOut.write();
      break;
    }

    for(int i=0; i<10; i++)
      flag[i] = false;

  }
  return RTC::RTC_OK;
}


/*
RTC::ReturnCode_t Summater::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t Summater::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t Summater::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/




extern "C"
{
 
  void SummaterInit(RTC::Manager* manager)
  {
    RTC::Properties profile(summater_spec);
    manager->registerFactory(profile,
                             RTC::Create<Summater>,
                             RTC::Delete<Summater>);
  }
  
};


